/****************************************************************
*Copyright (c) 2018 Tecnalia.
*Licensed under MIT License (the "License");
*Permission is hereby granted, free of charge, to any person obtaining a copy 
of this software and associated documentation files (the "Software"), to deal 
in the Software without restriction, including without limitation the rights 
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
copies of the Software, and to permit persons to whom the Software is furnished 
to do so, subject to the following conditions:
*The above copyright notice and this permission notice shall be included in all 
copies or substantial portions of the Software.
*
*
*THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, 
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A 
PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE 
OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

*Contributors (in alphabetical order):
*Alberto Molinuevo 								Tecnalia
*Gorka Benguria                                 Tecnalia
*Iñaki Etxaniz                                  Tecnalia
*Juncal Alonso                                  Tecnalia
*Leire Orue-Echevarria                          Tecnalia
*Maria Jose Lopez                               Tecnalia
*Marisa Escalante                               Tecnalia
*
*Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
*****************************************************************************/

package eu.decideh2020.acsmi.monitoring.server.api.impl;

import java.util.List;
import java.util.Timer;
import java.io.IOException;
import java.util.ArrayList;

import eu.DECIDEh2020.appManager.models.AppDescription;
import eu.DECIDEh2020.appManager.models.VirtualMachine;
import eu.decideh2020.acsmi.monitoring.server.api.impl.MonitoredVm;
import eu.decideh2020.telegraf.file.FileParser;
import eu.decideh2020.telegraf.file.FileWriter;


public class monitoringconfiguration {
	
	
public static List<MonitoredVm> listcsip = new ArrayList<MonitoredVm>();
		
public void configuretelegraf(AppDescription description) {
		AppDescription currentdescription=description;
		List<VirtualMachine> vmlist= currentdescription.getVirtualMachines();
		//List<MonitoredVm> listcsip = new ArrayList<MonitoredVm>();
		List<String> ipvalues = new ArrayList<String> ();
		for (VirtualMachine vm : vmlist) {
			MonitoredVm mvm = new MonitoredVm();
			mvm.setCsId(vm.getId());
			mvm.setdockerHostPublicIP(vm.getDockerHostPublicIp());
			mvm.setAppinstanceId(description.getApplicationInstanceId());
			mvm.setAppdesc(currentdescription);
			listcsip.add(mvm);
			System.out.println ("CsId "+mvm.getCsId());
			System.out.println ("dockerHostPublicIP "+mvm.getdockerHostPublicIP());
			System.out.println ("AppInstance ID "+mvm.getAppinstanceId());
			}
		//Configure telegraf
		if (!listcsip.isEmpty()) {
		for (MonitoredVm csip: listcsip) {
			ipvalues.add(csip.getdockerHostPublicIP());
			}
		}
		try {
			FileParser parser = new FileParser("D:\\2017-Decide\\telegraf\\telegraf.conf");
			parser.duplicatePlugin("inputs.ping");
			parser.changePluginComment("inputs.ping",2, false);
			parser.changePropertyValue("inputs.ping",2, "count", "1");
			//parser.changePropertyComment("inputs.ping",2, "count", false);
			parser.changePropertyValues("inputs.ping", 2, "urls", ipvalues);
			//parser.changePropertyComment("inputs.ping",2,"urls", false);
			FileWriter.writeFile("D:\\2017-Decide\\telegraf\\telegraf.conf", parser.getDocument());
		
		} catch (Exception e) {
			e.printStackTrace();
			}
		Timer timer = new Timer();
		CsSlaAssessment currentcsslaassessment = new CsSlaAssessment(); 
		//CsSlaAssessment currentassessment = new CsSlaAssessment();
		//currentassessment.csnfrassessment();
		timer.schedule(currentcsslaassessment, 0, 5000);
		}
}
