class CleanUpJob
  require 'fileutils'

  include SuckerPunch::Job

  TOLERATE_PERIOD = 1.day
  PERFORM_EVERY = 1.hour.to_i

  def perform
    sessions = Session.joins(:contracting_resources).where("contracting_resources.status = 'waiting'")
                                                    .where('sessions.created_at < ?', TOLERATE_PERIOD.ago)
    sessions.each(&:destroy)

    mask = File.join(ApplicationDescription.storage_path, '*')
    Dir[mask].each do |dir|
      stale = File.mtime(dir) < Time.now - TOLERATE_PERIOD
      next unless stale
      FileUtils.remove_dir(dir)
    end

    CleanUpJob.perform_in(PERFORM_EVERY)
  end

end