Rails.application.routes.draw do
  root to: 'welcome#index'

  resources :sessions, only: [:index] do
    collection do
      post :start_demo
      get :failed
    end
    member do
      post :own_creds_or_contract
      post :use_own_creds
      get :setup_contracting
      get :success

      # AJAX
      post :check_existing_contract
      post :prepare_new_contract

      post :hide_schema_warnings
    end
  end

  resources :contracts, only: %i[index show destroy]

  get '/license', to: 'information#license'
  get '/api_info', to: 'information#api_info'
  get '/usage_terms', to: 'information#usage_terms'

  delete '/sign_out', to: 'user_sessions#destroy', as: :sign_out
  post '/sign_in', to: 'user_sessions#create', as: :sign_in
  get '/sign_in', to: 'user_sessions#new'

  namespace :decide do
    namespace :acsmi do
      namespace :contracting do
        namespace :api, defaults: {format: :json}, constraints: {format: :json} do
          namespace :v1 do
            resources :sessions, only: [:create] do
              member do
                get :credentials
                get :status
              end
            end
          end
        end
      end
    end
  end

end
