/*******************************************************************************
 * Copyright (c) 2017 Tecnalia.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 	
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 * The code has been contributed over a stub generated with the JHipster
 * Application generator http://www.jhipster.tech/.
 * 
 * Contributors (in alphabetical order):
 * 
 * Gorka Benguria                       Tecnalia
 * Iñaki Etxaniz                        Tecnalia
 * Juncal Alonso                        Tecnalia
 * Leire Orue-Echevarria                Tecnalia
 * Maria Jose lopez                     Tecnalia
 * Marisa Escalante                     Tecnalia
 * 
 * Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
 ******************************************************************************/
package eu.decideh2020.acsmi.backend.services.server.domain;

import java.io.Serializable;
import java.time.ZonedDateTime;
import java.util.Objects;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;

import org.hibernate.annotations.Cache;
import org.hibernate.annotations.CacheConcurrencyStrategy;

/**
 * A ServiceTypicalAttribute.
 */
@Entity
@Table(name = "service_class_attribute")
@Cache(usage = CacheConcurrencyStrategy.NONSTRICT_READ_WRITE)
public class ServiceClassAttribute extends AbstractAuditingEntity implements Serializable {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    @NotNull
    @Column(name = "weight", nullable = false)
    private Integer weight;
    
    @NotNull
    @Column(name = "ismandatory", nullable = false)
    private Boolean ismandatory;

    @Column(name = "deleted_date")
    private ZonedDateTime deleteddate;
    
    @NotNull
    @Column(name = "serviceclassid", nullable = false)
    private Long serviceclassid;
    
    @NotNull
    @Column(name = "serviceattributetypeid", nullable = false)
    private Long serviceattributetypeid;
    
    private transient String serviceattributetypename;
    private transient Boolean isenumeration;
    private transient Boolean ischecklist;
    private transient Boolean isfunctionalrequirement;
    private transient Long parentid;
    private transient Long childid;
    
    
    public ServiceClassAttribute() {}

	public ServiceClassAttribute(final Long id, final Integer weight,
			final Boolean ismandatory, final Long serviceclassid, final Long serviceattributetypeid,
			final ZonedDateTime deleteddate, final String serviceattributetypename,
			final boolean isenumeration, final boolean ischecklist,
			final boolean isfunctionalrequirement, final Long parentid, final Long childid) {
    	this.id = id;
    	this.weight = weight;
    	this.ismandatory = ismandatory;
    	this.serviceclassid = serviceclassid;
    	this.serviceattributetypeid = serviceattributetypeid;
    	this.deleteddate = deleteddate;
    	this.serviceattributetypename = serviceattributetypename;
    	this.isenumeration = isenumeration;
    	this.ischecklist = ischecklist;
    	this.isfunctionalrequirement = isfunctionalrequirement;
    	this.parentid = parentid;
    	this.childid = childid;
    }
    

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }
    
    public Integer getWeight() {
        return weight;
    }

    public ServiceClassAttribute weight(Integer weight) {
        this.weight = weight;
        return this;
    }

    public void setWeight(Integer weight) {
        this.weight = weight;
    }
    
    public boolean isIsmandatory() {
        return ismandatory;
    }

    public ServiceClassAttribute ismandatory(boolean ismandatory) {
        this.ismandatory = ismandatory;
        return this;
    }

    public void setIsmandatory(boolean ismandatory) {
        this.ismandatory = ismandatory;
    }

    public ZonedDateTime getDeleteddate() {
        return deleteddate;
    }

    public ServiceClassAttribute deleteddate(ZonedDateTime deleteddate) {
        this.deleteddate = deleteddate;
        return this;
    }

    public void setDeleteddate(ZonedDateTime deleteddate) {
        this.deleteddate = deleteddate;
    }
    
    public Long getServiceclassid() {
        return serviceclassid;
    }

    public ServiceClassAttribute serviceclassid(Long serviceclassid) {
        this.serviceclassid = serviceclassid;
        return this;
    }

    public void setServiceclassid(Long serviceclassid) {
        this.serviceclassid = serviceclassid;
    }
    
    public Long getServiceattributetypeid() {
        return serviceattributetypeid;
    }

    public ServiceClassAttribute serviceattributetypeid(Long serviceattributetypeid) {
        this.serviceattributetypeid = serviceattributetypeid;
        return this;
    }

    public void setServiceattributetypeid(Long serviceattributetypeid) {
        this.serviceattributetypeid = serviceattributetypeid;
    }
    
    public String getServiceattributetypename() {
    	return serviceattributetypename;
    }
    
    public void setServiceattributetypename(String serviceattributetypename) {
    	this.serviceattributetypename = serviceattributetypename;
    }
    
    public Boolean isIsenumeration() {
    	return isenumeration;
    }
    
    public void setIsenumeration(Boolean isenumeration) {
    	this.isenumeration = isenumeration;
    }
    
    public Boolean isIschecklist() {
    	return ischecklist;
    }
    
    public void setIschecklist(Boolean ischecklist) {
    	this.ischecklist = ischecklist;
    }
    
    public boolean isIsfunctionalrequirement() {
        return isfunctionalrequirement;
    }

    public void setIsfunctionalrequirement(boolean isfunctionalrequirement) {
        this.isfunctionalrequirement = isfunctionalrequirement;
    }
    
    public Long getParentid() {
        return parentid;
    }

    public void setParentid(Long parentid) {
        this.parentid = parentid;
    }
    
    public Long getChildid() {
        return childid;
    }

    public void setChildid(Long childid) {
        this.childid = childid;
    }


    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        ServiceClassAttribute serviceTypicalAttribute = (ServiceClassAttribute) o;
        if (serviceTypicalAttribute.getId() == null || getId() == null) {
            return false;
        }
        return Objects.equals(getId(), serviceTypicalAttribute.getId());
    }

    @Override
    public int hashCode() {
        return Objects.hashCode(getId());
    }

    @Override
    public String toString() {
        return "ServiceClassAttribute{" +
            "id=" + getId() +
            ", weight='" + getWeight() + "'" +
            ", ismandatory='" + isIsmandatory() + "'" +
            ", deleteddate='" + getDeleteddate() + "'" +
            ", serviceclassid='" + getServiceclassid() + "'" +
            ", serviceattributetypeid='" + getServiceattributetypeid() + "'" +
            "}";
    }
}
