/*******************************************************************************
 * Copyright (c) 2017 Tecnalia.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 	
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 * The code has been contributed over a stub generated with the JHipster
 * Application generator http://www.jhipster.tech/.
 * 
 * Contributors (in alphabetical order):
 * 
 * Gorka Benguria                       Tecnalia
 * Iñaki Etxaniz                        Tecnalia
 * Juncal Alonso                        Tecnalia
 * Leire Orue-Echevarria                Tecnalia
 * Maria Jose lopez                     Tecnalia
 * Marisa Escalante                     Tecnalia
 * 
 * Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
 ******************************************************************************/
package eu.decideh2020.acsmi.backend.services.server.domain;

import java.io.Serializable;
import java.time.Instant;
import java.time.ZonedDateTime;
import java.util.Objects;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;

import org.hibernate.annotations.Cache;
import org.hibernate.annotations.CacheConcurrencyStrategy;

/**
 * A ServiceIncidence.
 */
@Entity
@Table(name = "service_incidence")
@Cache(usage = CacheConcurrencyStrategy.NONSTRICT_READ_WRITE)
public class ServiceIncidence extends AbstractAuditingEntity implements Serializable {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    @NotNull
    @Column(name = "timestamp", nullable = false)
    private Long timestamp;
    
    @NotNull
    @Size(max = 60)
    @Column(name = "detail", length = 60, nullable = false)
    private String detail;
    
    @NotNull
    @Column(name = "serviceid", nullable = false)
    private Long serviceid;

    @Column(name = "deleted_date")
    private ZonedDateTime deleteddate;
    
    
    public ServiceIncidence() {}
    
    public ServiceIncidence(final Long id, final Long timestamp,
    		final String detail, final Long serviceid,
    		final Instant createddate, final Instant lastmodifieddate) {
    	this.id = id;
    	this.timestamp = timestamp;
    	this.detail = detail;
    	this.serviceid = serviceid;
    	setCreatedDate(createddate);
    	setLastModifiedDate(lastmodifieddate);
    }
    

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Long getTimestamp() {
        return timestamp;
    }

    public ServiceIncidence timestamp(Long timestamp) {
        this.timestamp = timestamp;
        return this;
    }

    public void setTimestamp(Long timestamp) {
        this.timestamp = timestamp;
    }
    
    public String getDetail() {
        return detail;
    }

    public ServiceIncidence detail(String detail) {
        this.detail = detail;
        return this;
    }

    public void setDetail(String detail) {
        this.detail = detail;
    }
    
    public Long getServiceid() {
        return serviceid;
    }

    public ServiceIncidence serviceid(Long serviceid) {
        this.serviceid = serviceid;
        return this;
    }

    public void setServiceid(Long serviceid) {
        this.serviceid = serviceid;
    }
    
    public ZonedDateTime getDeleteddate() {
        return deleteddate;
    }

    public ServiceIncidence deleteddate(ZonedDateTime deleteddate) {
        this.deleteddate = deleteddate;
        return this;
    }

    public void setDeleteddate(ZonedDateTime deleteddate) {
        this.deleteddate = deleteddate;
    }


    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        ServiceIncidence serviceIncidence = (ServiceIncidence) o;
        if (serviceIncidence.getId() == null || getId() == null) {
            return false;
        }
        return Objects.equals(getId(), serviceIncidence.getId());
    }

    @Override
    public int hashCode() {
        return Objects.hashCode(getId());
    }

    @Override
    public String toString() {
    	StringBuffer buffer = new StringBuffer("ServiceIncidence{");
    	buffer.append("id=").append(getId());
    	buffer.append(", timestamp=").append(getTimestamp());
    	buffer.append(", detail=").append(getDetail());
    	buffer.append(", serviceid=").append(getServiceid());
    	buffer.append(", deleteddate=").append(getDeleteddate()).append("}");
    	return buffer.toString();
    }
}
