/*******************************************************************************
 * Copyright (c) 2017 Tecnalia.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 	
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 * The code has been contributed over a stub generated with the JHipster
 * Application generator http://www.jhipster.tech/.
 * 
 * Contributors (in alphabetical order):
 * 
 * Gorka Benguria                       Tecnalia
 * Iñaki Etxaniz                        Tecnalia
 * Juncal Alonso                        Tecnalia
 * Leire Orue-Echevarria                Tecnalia
 * Maria Jose lopez                     Tecnalia
 * Marisa Escalante                     Tecnalia
 * 
 * Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
 ******************************************************************************/
package eu.decideh2020.acsmi.backend.services.server.domain.vo;

import java.io.Serializable;
import java.util.Objects;

/**
 * An AttributeVO.
 */
public class AttributeVO implements Serializable {

    private static final long serialVersionUID = 1L;

    private Long typeid;
    private String name;
    private String nfrname;
    private Boolean isenumeration;
    private Boolean ischecklist;
    private Boolean iscommon;
    private Boolean isfunctionalrequirement;
    private Long parentid;
    private Long childid;
    private String units;
    private String unitfactor;
    private String unitrule;
    private String checklistevalrule;
    private String unitvalue;
    private String checklistvalue;
    private Long valueid;
    private String value;
    private String human;	// Definition
    
    private Long classattributeid;
    private Integer weight;
    private Boolean ismandatory;
    

    public Long getTypeid() {
        return typeid;
    }

    public void setTypeid(final Long typeid) {
        this.typeid = typeid;
    }
    
    public String getName() {
        return name;
    }

    public void setName(final String name) {
        this.name = name;
    }
    
    public String getNfrname() {
        return nfrname;
    }

    public void setNfrname(final String nfrname) {
        this.nfrname = nfrname;
    }
    
    public Boolean isIsenumeration() {
        return isenumeration;
    }

    public void setIsenumeration(final Boolean isenumeration) {
        this.isenumeration = isenumeration;
    }
    
    public Boolean isIschecklist() {
        return ischecklist;
    }

    public void setIschecklist(final Boolean ischecklist) {
        this.ischecklist = ischecklist;
    }
    
    public Boolean isIscommon() {
        return iscommon;
    }

    public void setIscommon(final Boolean iscommon) {
        this.iscommon = iscommon;
    }
    
    public Boolean isIsfunctionalrequirement() {
        return isfunctionalrequirement;
    }

    public void setIsfunctionalrequirement(final Boolean isfunctionalrequirement) {
        this.isfunctionalrequirement = isfunctionalrequirement;
    }
    
    public Long getParentid() {
        return parentid;
    }

    public void setParentid(final Long parentid) {
        this.parentid = parentid;
    }
    
    public Long getChildid() {
        return childid;
    }

    public void setChildid(final Long childid) {
        this.childid = childid;
    }
    
    public String getUnits() {
        return units;
    }

    public void setUnits(final String units) {
        this.units = units;
    }
    
    public String getUnitfactor() {
        return unitfactor;
    }

    public void setUnitfactor(final String unitfactor) {
        this.unitfactor = unitfactor;
    }
    
    public String getUnitrule() {
        return unitrule;
    }

    public void setUnitrule(final String unitrule) {
        this.unitrule = unitrule;
    }
    
    public String getChecklistevalrule() {
        return checklistevalrule;
    }

    public void setChecklistevalrule(final String checklistevalrule) {
        this.checklistevalrule = checklistevalrule;
    }
    
    public String getUnitvalue() {
        return unitvalue;
    }

    public void setUnitvalue(final String unitvalue) {
        this.unitvalue = unitvalue;
    }
    
    public String getChecklistvalue() {
        return checklistvalue;
    }

    public void setChecklistvalue(final String checklistvalue) {
        this.checklistvalue = checklistvalue;
    }
    
    public Long getValueid() {
        return valueid;
    }

    public void setValueid(final Long valueid) {
        this.valueid = valueid;
    }
    
    public String getValue() {
        return value;
    }

    public void setValue(final String value) {
        this.value = value;
    }
    
    public String getHuman() {
        return human;
    }

    public void setHuman(final String human) {
        this.human = human;
    }
    
    public Long getClassattributeid() {
        return classattributeid;
    }

    public void setClassattributeid(final Long classattributeid) {
        this.classattributeid = classattributeid;
    }
    
    public Integer getWeight() {
        return weight;
    }

    public void setWeight(final Integer weight) {
        this.weight = weight;
    }
    
    public Boolean isIsmandatory() {
        return ismandatory;
    }

    public void setIsmandatory(final Boolean ismandatory) {
        this.ismandatory = ismandatory;
    }


    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        AttributeVO attributeVO = (AttributeVO) o;
        if (attributeVO.getTypeid() == null || getTypeid() == null) {
            return false;
        }
        return Objects.equals(getTypeid(), attributeVO.getTypeid());
    }

    @Override
    public int hashCode() {
        return Objects.hashCode(getTypeid());
    }

    @Override
    public String toString() {
        return "AttributeVO{" +
            "typeid=" + getTypeid() +
            ", name=" + getName() +
            ", nfrname=" + getNfrname() +
            ", isenumeration=" + isIsenumeration() +
            ", ischecklist=" + isIschecklist() +
            ", iscommon=" + isIscommon() +
            ", isfunctionalrequirement=" + isIsfunctionalrequirement() +
            ", parentid=" + getParentid() +
            ", childid=" + getChildid() +
            ", units=" + getUnits() +
            ", unitfactor=" + getUnitfactor() +
            ", unitrule=" + getUnitrule() +
            ", checklistevalrule=" + getChecklistevalrule() +
            ", unitvalue=" + getUnitvalue() +
            ", checklistvalue=" + getChecklistvalue() +
            ", valueid=" + getValueid() +
            ", value=" + getValue() +
            ", human=" + getHuman() +
            ", classattributeid=" + getClassattributeid() +
            ", weight=" + getWeight() +
            ", ismandatory=" + isIsmandatory() +
            "}";
    }
}
