/*******************************************************************************
 * Copyright (c) 2017 Tecnalia.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 	
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 * The code has been contributed over a stub generated with the JHipster
 * Application generator http://www.jhipster.tech/.
 * 
 * Contributors (in alphabetical order):
 * 
 * Gorka Benguria                       Tecnalia
 * Iñaki Etxaniz                        Tecnalia
 * Juncal Alonso                        Tecnalia
 * Leire Orue-Echevarria                Tecnalia
 * Maria Jose lopez                     Tecnalia
 * Marisa Escalante                     Tecnalia
 * 
 * Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
 ******************************************************************************/
package eu.decideh2020.acsmi.backend.services.server.domain.vo;

import java.io.Serializable;
import java.util.Objects;

/**
 * A InfluxDBConfigVO.
 */
public class InfluxDBConfigVO implements Serializable {

    private static final long serialVersionUID = 1L;
    
    private String url;
    private String database;
    private Integer repeat;
    private Long delay;
    private Long interval;
    
    
    public InfluxDBConfigVO() {
    	this.url = null;
    	this.database = null;
    	this.repeat = null;
    	this.delay = null;
    	this.interval = null;
    }
    
    public InfluxDBConfigVO(String url, String database, Integer repeat, Long delay, Long interval) {
    	this.url = url;
    	this.database = database;
    	this.repeat = repeat;
    	this.delay = delay;
    	this.interval = interval;
    }
    
    
    public String getUrl() {
        return url;
    }
   
    public void setUrl(final String url) {
        this.url = url;
    }
    
    public String getDatabase() {
        return database;
    }
   
    public void setDatabase(final String database) {
        this.database = database;
    }
    
    public Integer getRepeat() {
        return repeat;
    }

    public void setRepeat(final Integer repeat) {
        this.repeat = repeat;
    }
    
    public Long getDelay() {
        return delay;
    }

    public void setDelay(final Long delay) {
        this.delay = delay;
    }
    
    public Long getInterval() {
        return interval;
    }

    public void setInterval(final Long interval) {
        this.interval = interval;
    }


    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        InfluxDBConfigVO influxDBConfigVO = (InfluxDBConfigVO) o;
        if (influxDBConfigVO.getUrl() == null || getUrl() == null) {
            return false;
        }
        return Objects.equals(getUrl(), influxDBConfigVO.getUrl());
    }

    @Override
    public int hashCode() {
        return Objects.hashCode(getUrl());
    }

    @Override
    public String toString() {
    	return "InfluxDBConfigVO{" +
                "url=" + getUrl() +
                ", database='" + getDatabase() + "'" +
                ", repeat='" + getRepeat() + "'" +
                ", delay='" + getDelay() + "'" +
                ", interval='" + getInterval() + "'" +
                "}";
    }
}
