/*******************************************************************************
 * Copyright (c) 2017 Tecnalia.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 	
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 * The code has been contributed over a stub generated with the JHipster
 * Application generator http://www.jhipster.tech/.
 * 
 * Contributors (in alphabetical order):
 * 
 * Gorka Benguria                       Tecnalia
 * Iñaki Etxaniz                        Tecnalia
 * Juncal Alonso                        Tecnalia
 * Leire Orue-Echevarria                Tecnalia
 * Maria Jose lopez                     Tecnalia
 * Marisa Escalante                     Tecnalia
 * 
 * Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
 ******************************************************************************/
package eu.decideh2020.acsmi.backend.services.server.repository;

import java.util.List;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

import eu.decideh2020.acsmi.backend.services.server.domain.ServiceAttributeType;


/**
 * Spring Data JPA repository for the ServiceAttributeType entity.
 */
@Repository
public interface ServiceAttributeTypeRepository extends JpaRepository<ServiceAttributeType,Long> {
	@Query("select new eu.decideh2020.acsmi.backend.services.server.domain.ServiceAttributeType(s.id, s.name, s.nfrname, s.isenumeration, s.ischecklist, s.iscommon, s.isfunctionalrequirement, s.parentid, s.childid, s.units, s.unitfactor, s.unitrule, s.checklistevalrule, s.deleteddate) from ServiceAttributeType s join ServiceClassAttribute scta on s.id = scta.serviceattributetypeid where scta.serviceclassid = 0 or scta.serviceclassid = ?1 order by scta.serviceclassid, scta.weight")
	public List<ServiceAttributeType> findServiceAttributeTypesByClassid(Long classid);
	
	@Query("select new eu.decideh2020.acsmi.backend.services.server.domain.ServiceAttributeType(s.id, s.name, s.nfrname, s.isenumeration, s.ischecklist, s.iscommon, s.isfunctionalrequirement, s.parentid, s.childid, s.units, s.unitfactor, s.unitrule, s.checklistevalrule, s.deleteddate) from ServiceAttributeType s join ServiceClassAttribute scta on s.id = scta.serviceattributetypeid where (scta.serviceclassid = 0 or scta.serviceclassid = ?1) and s.id not in (?2) order by scta.serviceclassid, scta.weight")
	public List<ServiceAttributeType> findServiceAttributeTypesByClassidExcludingAttributes(Long classid, List<Long> excludedAttributeId);
	
	@Query("select s from ServiceAttributeType s where s.parentid != null")
	public List<ServiceAttributeType> findChildAttributes();
}
